

Double_t  func( Double_t *x, Double_t *par)
{ 
  Double_t xx = x[0];
    
  Double_t Norm   =   par[0];
  Double_t Q      =   par[1];
  Double_t s      =   par[2];
  Double_t lambda =   par[3];
  //Double_t lambda = 1/par[3];
  Double_t theta  =   par[4];     
  Double_t mu     =   par[5];
  
  Double_t arg = 0.0;
  if ( s!=0 ) arg = ( xx - Q )/s;    
  else cout << "Error: The code tries to divide by zero." << endl;
  
  Double_t omega  = 1/sqrt(2.)*( ( arg - s*lambda*(1+theta) ) );
  Double_t omega2 = pow(omega, 2);   
  
  Double_t Result =  1/( sqrt( 2 * TMath::Pi() ) * s ) * ROOT::Math::poisson_pdf(0,mu) * TMath::Exp( -0.5*arg*arg );
  
  Double_t PAR = 0.0;
  Double_t In  = 0.0;
  
  Double_t xi    = 0.0;
  // Appr.
  Double_t AppF  = 0.0;
  Double_t AppU1 = 0.0;
  Double_t AppU2 = 0.0;
  Double_t AA, BB;  
 
  gsl_sf_result res, res1, res2;
  
  cout << "Norm = " << Norm << ", Q = " << Q << ", s = " << s << ", lambda = " << lambda << ", mu = " << mu << endl; 
  cout << "theta = " << theta <<", x = " << xx << ", omega =  " << omega << ", omega2 = " << omega2 << endl;
    
  for(Int_t i=1; i<NoLoop; i++)                                                                                  
    {
      xi = 0.5 * i * ( 1 + theta );
      cout << "* " << "i = " << i << ", xi = " << xi << endl;      
      cout << "---" << endl;
      
      if  ( omega > lim )
	{
	  cout << "1" << endl;
	  
	  AA   = 0.5 - xi;
	  BB   = 1.0 - xi;
	  	  AppF = 2.0 * ( 1.0 + AA*BB/pow(omega,2) + AA*(AA+1)*BB*(BB+1)/(2*pow(omega,4))  + AA*(AA+1)*(AA+2)*BB*(BB+1)*(BB+2)/(6*pow(omega,6)) );
	  //	  AppF = 2.0 * ( 1.0 + AA*BB*pow(omega,-2) + AA*(AA+1)*BB*(BB+1)*pow(omega,-4)/2. + AA*(AA+1)*(AA+2)*BB*(BB+1)*(BB+2)*pow(omega, -6)/6. );
	  //      AppF = 2.0 * ( 1.0 + AA*BB*pow(omega,-2) + AA*(AA+1)*BB*(BB+1)*pow(omega,-4)/2. );
	   
	  In = 0.5 * pow( sqrt(2.0) * s, i * ( 1+theta ) ) *  TMath::Exp( -0.5*arg*arg + omega2 ) * sqrt( TMath::Pi() ) * pow( omega, 2*xi-1) * AppF;
	}
      
      else if ( omega >= 0.0 && omega <= lim ) 
	{
	  cout << "2" << endl;
	  
	  gsl_sf_hyperg_1F1_e(       xi, 0.5, omega2, &res );
	  /*
	  if ( TMath::Abs(res.err/res.val  ) > MyPres ) 
	    {
	      cout << "*Warning: Relative error in estimating 1F1[1] greater than " << MyPres << " ( check if important! )" << endl;
	      cout << " 1F1( " << xi << ", 0.5, " << omega2 << " ) = " << res.val << ", error = " << res.err << endl;
	    }
	  */
	  
	  gsl_sf_hyperg_1F1_e( 0.5 + xi, 1.5, omega2, &res1);
	  /*
	  if ( TMath::Abs(res1.err/res1.val) > MyPres ) 
	    {
	      cout << "*Warning: Relative error in estimating 1F1[2] greater than " << MyPres << " ( check if important! )" << endl;
	      cout << " 1F1( " << 0.5 + xi << ", 1.5, " << omega2 << " ) = " << res1.val << ", error = " << res1.err << endl;
	    }
	  */
	  
	  cout << "--- " << ", 1F1( " <<       xi << ", 0.5, " << omega2 << " )" << " = " <<  res.val << endl;
	  cout << "--- " << ", 1F1( " << 0.5 + xi << ", 0.5, " << omega2 << " )"  << " = " << res1.val << endl;
	  
	  PAR =  ( gsl_sf_gamma( xi )* res.val + 2*omega*gsl_sf_gamma( 0.5 + xi )* res1.val );	  
	  In  = 0.5 * pow( sqrt(2.0) * s, i * ( 1+theta ) ) * TMath::Exp( -0.5 * arg*arg ) * PAR;
	}                  	  
      
      else if ( omega<0 && omega>-0.1 && xi>8.0)
	{
	  cout << "3" << endl;
	  
	  for (Int_t ii=0; ii<7; ++ii)
	    {
	      AppU1 = AppU1 +  sqrt( TMath::Pi() )/gsl_sf_gamma(xi + 0.5) * 
		( gsl_sf_poch(xi,ii)*pow(omega2, ii) )/( gsl_sf_poch(0.5,ii)*gsl_sf_fact(ii) );
	      AppU2 = AppU2 +  -2*sqrt( TMath::Pi() )/gsl_sf_gamma(xi)*pow(omega2,0.5) * 
		( gsl_sf_poch(xi+0.5,ii)*pow(omega2,ii) )/( gsl_sf_poch(1.5,ii)*gsl_sf_fact(ii) );
	    }
	  
	  In = pow( s/sqrt(2.), i * ( 1 + theta ) ) * gsl_sf_gamma( 2 * xi ) *  TMath::Exp( -0.5*arg*arg) * ( AppU1+AppU2 );
	}	
      
      else 
	{
	  cout << "4" << endl;
	  
	  gsl_sf_hyperg_U_e( xi, 0.5, omega2, &res2);	  

	  /*
	  if ( TMath::Abs(res2.err/res2.val) > MyPres ) 
	    {
	      cout << "*Warning: Relative error in estimating U greater than " << MyPres << " ( check if important! )" << endl;
	      cout << " U( " << xi << ", 0.5, " << omega2 << " )" << " = " << res2.val << ", error: " << res2.err << endl;
	    }
	  */
	  
	  cout << "--- " << ", U( " <<       xi << ", 0.5, " << omega2 << " )" << " = " << res2.val << endl;
	  
	  In = pow( s/sqrt(2.), i*( 1+theta ) ) * gsl_sf_gamma( 2*xi ) *TMath::Exp( -0.5*arg*arg ) * res2.val;
	}
      
      cout << "---" << endl; 
     
      Result  = Result + 1/( sqrt( 2 * TMath::Pi() ) * s ) * ROOT::Math::poisson_pdf(i,mu) 
	* pow( lambda*( 1+theta ), i * ( 1+theta ) ) / gsl_sf_gamma( i*( 1+theta ) ) * In;
    }
  
  Result = wbin * Norm * Result;
  cout << " Result = " << Result << endl; 
  cout << "." << endl;
  return Result;
}
