
#include <string>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <sstream>
#include "TApplication.h"
#include "TH1.h"
#include "TF1.h"
#include "TFile.h"
#include "TMath.h"
#include "TNtuple.h"
#include "TCanvas.h"
#include "TGraph.h"
#include "TLegend.h"
#include "TLatex.h"
#include "TLine.h"
#include "TPaveText.h"
#include "TStyle.h"
#include "Math/Math.h"
#include "Math/PdfFuncMathCore.h"
#include "gsl/gsl_sf_hyperg.h"
#include "gsl/gsl_sf_gamma.h"
#include "gsl/gsl_math.h"
#include "gsl/gsl_sf_exp.h"
#include "gsl/gsl_errno.h"
#include "gsl/gsl_sf_result.h"

using namespace std;

const Double_t NoLoop  = 6.0;

const Double_t wbin = 0.000999;
const Double_t lim = 10.0;

#include "func.cc"

void macro()
{
  TFile f("file.root", "read");
  TH1F *h1 = (TH1F*)f.Get("hnew");
  
  TCanvas *c1 = new TCanvas("c1", "");
  h1->Draw();
   
  TF1 *FitFunc  = new TF1("FitFunc" , func, -0.3, 0.9, 6);
  
  FitFunc->SetParameter( 0, 21220);  
  FitFunc->SetParameter( 1, 0.0307399);  
  FitFunc->SetParameter( 2, 0.00986262);  
  FitFunc->SetParameter( 3, 34);	        
  FitFunc->SetParameter( 4,  1.3 );
  FitFunc->SetParLimits( 4,  0.0, 10.0);	        
  
 
  FitFunc->SetParameter( 5, 0.16 );  // bad  
  //FitFunc->SetParameter( 5, 0.2 );   // good
  //FitFunc->SetParameter( 5, 0.02 );  // good  
  // FitFunc->SetParameter( 5, 0.3 );  // good  
  
  h1->Fit("FitFunc", "", "", -0.2, 0.7);
  
  c1->Update();
  c1->WaitPrimitive();  
}  

int main(int argc, char *argv[]) 
{
  TApplication theApp("App", &argc, argv);
  macro();
  theApp.Run();
}
